Status: Closed   

Priority: Normal   

Assignee:    

Target version:    

Description

In https://bugs.ruby-lang.org/issues/12694, we decided to have String#delete_prefix.

It would be nice to have String#delete_suffix method to delete suffix from a string for symmetry although it can be achieved with

String#chomp as:

class String

  def delete_suffix(substr)

    chomp(substr)

  end

  def delete_suffix!(substr)

    chomp!(substr)

  end

end

 Any opinions?

Associated revisions

Revision 510957df33be322875e7d863b9af6934f2574779 - 07/20/2017 04:29 PM - sonots (Naotoshi Seo)

string.c: add String#delete_suffix and String#delete_suffix!

to remove trailing suffix [Feature #13665] [Fix GH-1661]

string.c (rb_str_delete_suffix_bang): add a new method

to remove suffix destuctively.

string.c (rb_str_delete_suffix): add a new method

to remove suffix non-destuctively.

test/ruby/test_string.rb: add tests.

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@59377 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 510957df - 07/20/2017 04:29 PM - sonots (Naotoshi Seo)

string.c: add String#delete_suffix and String#delete_suffix!

to remove trailing suffix [Feature #13665] [Fix GH-1661]

string.c (rb_str_delete_suffix_bang): add a new method

to remove suffix destuctively.

string.c (rb_str_delete_suffix): add a new method

to remove suffix non-destuctively.

test/ruby/test_string.rb: add tests.

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@59377 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

History

#1 - 06/16/2017 10:34 PM - nobu (Nobuyoshi Nakada)

- Description updated

At yesterday meeting, a name lchomp was proposed but rejected because of the special deal of CR LF.

If delete_suffix will be introduced, it should keep CR before LF when the argument is LF only, as well as delete_prefix.
#2 - 06/21/2017 08:42 AM - shevegen (Robert A. Heiler)

I think the method's functionality is good to have.

#3 - 06/26/2017 04:54 AM - sonots (Naotoshi Seo)

I've sent a PR https://github.com/ruby/ruby/pull/1661.

I will merge if I get agreement at a ruby developer's meeting.

#4 - 07/14/2017 06:07 AM - matz (Yukihiro Matsumoto)

Looks good to me.

Matz.

#5 - 07/20/2017 04:29 PM - sonots (Naotoshi Seo)

- Status changed from Open to Closed

Applied in changeset trunk|r59377.

string.c: add String#delete_suffix and String#delete_suffix!

to remove trailing suffix [Feature #13665] [Fix GH-1661]

string.c (rb_str_delete_suffix_bang): add a new method

to remove suffix destuctively.

string.c (rb_str_delete_suffix): add a new method

to remove suffix non-destuctively.

test/ruby/test_string.rb: add tests.
